Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.pool
Interface KeyedObjectPool

All Known Implementing Classes:
  BaseKeyedObjectPool, GenericKeyedObjectPool, StackKeyedObjectPool

    public interface KeyedObjectPool

A "keyed" pooling interface.

A keyed pool pools instances of multiple types. Each type may be accessed using an arbitrary key.

Example of use:

     Object obj = null;
     Object key = "Key";

     try {
         obj = pool.borrowObject(key);
         //...use the object...
     } catch(Exception e) {
         // invalidate the object
         pool.invalidateObject(key, obj);
         // do not return the object to the pool twice
         obj = null;
     } finally {
         // make sure the object is returned to the pool
         if(null != obj) {
             pool.returnObject(key, obj);
         }
     }

`KeyedObjectPool` implementations may choose to store at most one instance per key value, or may choose to maintain a pool of instances for each key (essentially creating a `Map` of `pools`).

See `BaseKeyedObjectPool` for a simple base implementation.

Since:
  Pool 1.0
Version:
  $Revision: 962893 $ $Date: 2010-07-10 10:37:27 -0700 (Sat, 10 Jul 2010) $
Author:
  Rodney Waldhoff, Sandy McArthur
See Also:
  `KeyedPoolableObjectFactory`, `KeyedObjectPoolFactory`, `ObjectPool`, `BaseKeyedObjectPool`

Method Summary
`void` | `addObject(Object key)` Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool.
`Object` | `borrowObject(Object key)` Obtains an instance from this pool for the specified `key`.
`void` | `clear()` Clears the pool, removing all pooled instances (optional operation).
`void` | `clear(Object key)` Clears the specified pool, removing all pooled instances corresponding to the given `key` (optional operation).
`void` | `close()` Close this pool, and free any resources associated with it.
`int` | `getNumActive()` Returns the total number of instances current borrowed from this pool but not yet returned (optional operation).
`int` | `getNumActive(Object key)` Returns the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key` (optional operation).
`int` | `getNumIdle()` Returns the total number of instances currently idle in this pool (optional operation).
`int` | `getNumIdle(Object key)` Returns the number of instances corresponding to the given `key` currently idle in this pool (optional operation).
`void` | `invalidateObject(Object key, Object obj)` Invalidates an object from the pool.
`void` | `returnObject(Object key, Object obj)` Return an instance to the pool.
`void` | `setFactory(KeyedPoolableObjectFactory factory)` Deprecated. to be removed in pool 2.0

Method Detail

### borrowObject

    Object borrowObject(Object key)
                        throws Exception,
                               NoSuchElementException,
                               IllegalStateException

  Obtains an instance from this pool for the specified `key`.

  Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then validated with `validateObject`.

  By contract, clients must return the borrowed object using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface, using a `key` that is `equivalent` to the one used to borrow the instance in the first place.

  The behaviour of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations). Older versions of this method would return `null` to indicate exhaustion, newer versions are encouraged to throw a `NoSuchElementException`.

  Parameters:
    `key` - the key used to obtain the object
  Returns:
    an instance from this pool.
  Throws:
    `IllegalStateException` - after `close` has been called on this pool
    `Exception` - when `makeObject` throws an exception
    `NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance

### returnObject

    void returnObject(Object key,
                      Object obj)
                      throws Exception

  Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the instance in the first place.

  Parameters:
    `key` - the key used to obtain the object
    `obj` - a `borrowed` instance to be returned.
  Throws:
    `Exception`

### invalidateObject

    void invalidateObject(Object key,
                          Object obj)
                          throws Exception

  Invalidates an object from the pool.

  By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the `Object` in the first place.

  This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

  Parameters:
    `key` - the key used to obtain the object
    `obj` - a `borrowed` instance to be returned.
  Throws:
    `Exception`

### addObject

    void addObject(Object key)
                   throws Exception,
                          IllegalStateException,
                          UnsupportedOperationException

  Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool. `addObject` is useful for "pre-loading" a pool with idle objects (Optional operation).

  Parameters:
    `key` - the key a new instance should be added to
  Throws:
    `Exception` - when `KeyedPoolableObjectFactory.makeObject(java.lang.Object)` fails.
    `IllegalStateException` - after `close()` has been called on this pool.
    `UnsupportedOperationException` - when this pool cannot add new idle objects.

### getNumIdle

    int getNumIdle(Object key)
                   throws UnsupportedOperationException

  Returns the number of instances corresponding to the given `key` currently idle in this pool (optional operation). Returns a negative value if this information is not available.

  Parameters:
    `key` - the key to query
  Returns:
    the number of instances corresponding to the given `key` currently idle in this pool or a negative value if unsupported
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### getNumActive

    int getNumActive(Object key)
                     throws UnsupportedOperationException

  Returns the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key` (optional operation). Returns a negative value if this information is not available.

  Parameters:
    `key` - the key to query
  Returns:
    the number of instances corresponding to the given `key` currently borrowed in this pool or a negative value if unsupported
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### getNumIdle

    int getNumIdle()
                   throws UnsupportedOperationException

  Returns the total number of instances currently idle in this pool (optional operation). Returns a negative value if this information is not available.

  Returns:
    the total number of instances currently idle in this pool or a negative value if unsupported
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### getNumActive

    int getNumActive()
                     throws UnsupportedOperationException

  Returns the total number of instances current borrowed from this pool but not yet returned (optional operation). Returns a negative value if this information is not available.

  Returns:
    the total number of instances currently borrowed from this pool or a negative value if unsupported
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### clear

    void clear()
               throws Exception,
                      UnsupportedOperationException

  Clears the pool, removing all pooled instances (optional operation). Throws `UnsupportedOperationException` if the pool cannot be cleared.

  Throws:
    `UnsupportedOperationException` - when this implementation doesn't support the operation
    `Exception`

### clear

    void clear(Object key)
               throws Exception,
                      UnsupportedOperationException

  Clears the specified pool, removing all pooled instances corresponding to the given `key` (optional operation). Throws `UnsupportedOperationException` if the pool cannot be cleared.

  Parameters:
    `key` - the key to clear
  Throws:
    `UnsupportedOperationException` - when this implementation doesn't support the operation
    `Exception`

### close

    void close()
               throws Exception

  Close this pool, and free any resources associated with it.

  Calling `addObject` or `borrowObject` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

  Throws:
    `Exception`

### setFactory

    void setFactory(KeyedPoolableObjectFactory factory)
                    throws IllegalStateException,
                           UnsupportedOperationException

  Deprecated. to be removed in pool 2.0

  Sets the `factory` the pool uses to create new instances (optional operation). Trying to change the `factory` after a pool has been used will frequently throw an `UnsupportedOperationException`. It is up to the pool implementation to determine when it is acceptable to call this method.

  Parameters:
    `factory` - the `KeyedPoolableObjectFactory` used to create new instances.
  Throws:
    `IllegalStateException` - when the factory cannot be set at this time
    `UnsupportedOperationException` - when this implementation doesn't support the operation

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2011 The Apache Software Foundation. All Rights Reserved.